Foreman - Bug #16818

nested facts can lead to invalid links
10/06/2016 08:10 AM - Ohad Levy

Status: Closed
Priority: Normal
Assignee: Timo Goebel
Category: Facts
Target version:
Difficulty: Fixed in Releases: 1.24.0
Triaged: Yes Found in Releases: 1.14.3,1.19.1,1.21.2
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7005
Description

given the fact key mountpoints::/boot the following link is created which is 404
https://foreman.example.com/hosts/host.example.com/parent_facts/mountpoints::%2Fboot/facts

Related issues:

Related to Foreman - Feature #26852: Add mountpoint and partition exclude fac... Closed

Has duplicate Foreman - Bug #24774: Missing routes when checking facts contai... Duplicate
Has duplicate Ansible - Bug #25296: Viewing Ansible fact causes errors Duplicate
Has duplicate Foreman - Bug #25807: Error viewing external structured puppet ... Duplicate

Associated revisions

Revision c9648b06 - 08/29/2019 10:53 AM - Timo Goebel

fixes #16818 - support slash in fact name

History

#1 - 11/03/2016 06:51 AM - Gheorghe Nedelcu
Ohad Levy wrote:

given the fact key mountpoints::/boot the following link is created which is 404
https:/foreman.example.com/hosts/host.example.com/parent_facts/mountpoints::%2Fboot/facts

More info on this:
I have a custom fact in module which is returning this:

Debug: Facter: fact "db2" has resolved to {
Install => {
10.1 => {
Version => "10.1.0.0",
FixPack => "0",
Path => "/opt/ibm/db2/v10.1"
}

b
The Foreman's fact page cannot be loaded and gives this in the log:
2016-11-03 04:14:12 ac50£fd30 [app] [I] Started GET "/hosts/******xx*x** com/parent_facts/db2/facts" for 192.168

.1.14 at 2016-11-03 04:14:12 -0500
2016-11-03 04:14:12 ac50fd30 [app] [I] Processing by FactValuesController#index as HTML

2016-11-03 04:14:12 ac50£fd30 [appl]l [I] Parameters: {"host_id"=>"****kxxx*x** com", "parent_fact"=>"db2"}
2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered fact_values/_fact.html.erb (4.5ms)

2016-11-03 04:14:12 ac50fd30 [app] [I] Rendered fact_values/index.html.erb within layouts/application (30.2m
s)

2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered common/_searchbar.html.erb (22.5ms)

2016-11-03 04:14:12 ac50£fd30 [app] I[I] Rendered layouts/_application_content.html.erb (23.7ms)

2016-11-03 04:14:12 ac50£fd30 [appl]l [I] Rendered home/_user_dropdown.html.erb (8.2ms)
https://foreman.example.com/hosts/host.example.com/parent_facts/mountpoints::%2Fboot/facts
2016-11-03 04:14:12 ac50fd30 [app] [I] Read fragment views/tabs_and_title_records-3

2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered home/_org_swit
2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered home/_submenu.
2016-11-03 04:14:12 ac50£fd30 [app]l [I] Rendered home/_submenu.
2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered home/_submenu.
2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered home/_submenu.
2016-11-03 04:14:12 ac50£fd30 [app]l [I] Rendered home/_submenu.
2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered home/_submenu.
2016-11-03 04:14:12 ac50£fd30 [app] [I] Write fragment views/tabs

cher.
html.
html.
html.
html.
html.
html.

_and

2016-11-03 04:14:12 ac50£fd30 [appl [I] Rendered home/_topbar.html.erb
2016-11-03 04:14:12 ac50£fd30 [app] [I] Rendered layouts/base.html.erb
(Views:
2016-11-03 04:14:14 ac50fd30 [app] [I] Started GET "/hosts/******xx**x** com/parent_facts/db2::Install/facts" fo

2016-11-03 04:14:12 ac50£fd30 [app] [I] Completed 200 OK in 157ms

r 192.168.1.14 at 2016-11-03 04:14:14 -0500

2016-11-03 04:14:14 ac50fd30 [app] [I] Processing by FactValuesController#index as HTML
2016-11-03 04:14:14 ac50£fd30 [appl]l [I] Parameters: {"host_id"=>"***&xkxx*xk*x conm",

i@

2016-11-03 04:14:14 ac50£fd30 [app] [I] Rendered fact_values/_fact.html.erb

(0.2ms)
html.erb (0.5ms)
erb (5.6ms)
erb (2.1lms)
erb (5.9ms)
erb (7.4ms)
erb (4.2ms)
erb (4.4ms)
title_records-3 (1.3ms)
(56.6ms)
(60.9ms)

(4.1lms)

112.0ms | ActiveRecord:

11.6ms)

2016-11-03 04:14:14 ac50£fd30 [appl [I] Rendered fact_values/index.html.erb within layouts/application

s)

2016-11-03 04:14:14 ac50£fd30 [app] [I] Rendered common/_searchbar.html.erb
2016-11-03 04:14:14 ac50£fd30 [appl [I] Rendered layouts/_application_content.html.erb

2016-11-03 04:14:14 ac50£fd30 [app] [I] Rendered home/_user_dropdown.html.erb (3.7ms)

2016-11-03 04:14:14 ac50£fd30 [app] [I] Read fragment views/tabs_and_title_records-3

2016-11-03 04:14:14 ac50£fd30 [appl [I] Rendered home/_topbar.html.erb
2016-11-03 04:14:14 ac50£fd30 [app] [I] Rendered layouts/base.html.erb
(Views:
2016-11-03 04:14:19 ac50fd30 [app] [I] Started GET "/hosts/******xx**xx* com/parent_facts/db2::Install::10.1/fac

2016-11-03 04:14:14 ac50£fd30 [app] [I] Completed 200 OK in 76ms

ts" for 192.168.1.14 at 2016-11-03 04:14:19 -0500
2016-11-03 04:14:19 ac50£d30 [app] [F]

54.5ms | ActiveRecord:

(13.0ms)
(14.2ms)
(0.3ms)
(13.1ms)
(16.9ms)

6.7ms)

"parent_fact"=>"db2::Insta

(25.1m

| ActionController::RoutingError (No route matches [GET] "/hosts/*****x*x*x** com/parent_facts/db2::Install::1

0.1/facts"):
| lib/middleware/tagged_logging.rb:18:in “call'
I
I

2016-11-03 04:14:19 ac50£fd30 [app] [I] Started GET "/hosts/****x*x*x** com/parent_facts/db2::Install::10.1/fac

ts" for 192.168.1.14 at 2016-11-03 04:14:19 -0500
2016-11-03 04:14:19 ac50£d30 [app] [F]

| ActionController::RoutingError (No route matches [GET] "/hosts/******x**x* com/parent_facts/db2::Install::1

0.1/facts"):
| lib/middleware/tagged_logging.rb:18:in ‘call'
I
I

Foreman 1.13.1 all in one RHEL 7.2
#2 - 11/03/2016 07:56 AM - Gheorghe Nedelcu
| found that fact key using the "dot" is the wrong character in my case.

10.1 => {}

#3 - 01/12/2017 03:17 AM - Dominic Cleal
- Category changed from Web Interface to Facts

#4 - 01/17/2017 04:11 PM - James Perry

Could this be tied into the what the APIV2 is returning when queried for facts? When | run https://puppet/api/myhost.mydomain.com/facts | see the

first values are:

{...
"disks::sda":null,
"mountpoints":null,
"partitions":null

When running https:/puppet/api/myhost.mydomain.com/facts?per_page=1000 | see the same at the top, then | get

"partitions::/dev/sdal::size":"101.94 MiB",
"partitions::/dev/sdal::size_bytes":"106896384",
"partitions::/dev/sda1::mount":"/boot",
"partitions::/dev/sdal ::label":"/boot"
"partitions::/dev/sdal :filesystem":"ext3"
https://puppet/api/myhost.mydomain.com/facts
https://puppet/api/myhost.mydomain.com/facts?per_page=1000

So the information is here. Could it be related to it getting a "null" and then stopping to retrieve the data at that point? What module handles this
parsing so | could try to trace it out to see why it is breaking?

#5 - 01/17/2017 04:16 PM - James Perry

| also ran a more detailed search against /usr with https:/dlistmrfpup02.cbs.ad.cbs.net/api/hosts/myhost.com/facts?search=/usr. It has all of the
relevant data. So it is broken somewhere between the API calls and the module rendering it for the facts page in Foreman at the point where the
mountpoints are listed, but fail the expansion.

{
"total": 380,
"subtotal": 1,
"page": 1,
"per_page": 20,
"search": "/usr host = tlistmroel59.cbs.ad.cbs.net",
"sort": {
"by": null,
"order": null
}I

"results": {"myhost.com":{"mountpoints::/usr":null, "mountpoints::/usr::used":"1.31 GiB", "mountpoints::/usr::
used_bytes":"1411076096", "mountpoints::/usr::available":"1.99 GiB", "mountpoints::/usr::available_bytes":"21317
18144", "mountpoints::/usr::size":"3.30 GiB", "mountpoints::/usr::size_bytes":"3542794240", "mountpoints::/usr::c
apacity":"39.83%", "mountpoints::/usr::device":"/dev/mapper/VolGroup00-usr", "mountpoints::/usr::filesystem":"ex
t3", "mountpoints::/usr::options":"[\"rw\"]", "path":"/sbin:/usr/sbin:/bin:/usr/bin"}}

}

#6 - 06/05/2017 09:36 AM - James Perry

Any updates on this bug or workarounds? | find it is still present in 1.14.3.

#7 - 01/10/2019 09:09 PM - Tomer Brisker
- Has duplicate Bug #24774: Missing routes when checking facts containing /' added

#8 - 03/06/2019 01:35 PM - Ewoud Kohl van Wijngaarden
- Triaged changed from No to Yes

- Found in Releases 1.19.1 added

#9 - 04/10/2019 01:23 PM - Ewoud Kohl van Wijngaarden
- Related to Bug #25296: Viewing Ansible fact causes errors added

#10 - 04/10/2019 01:42 PM - Ewoud Kohl van Wijngaarden
- Related to deleted (Bug #25296: Viewing Ansible fact causes errors)

#11 - 04/10/2019 01:43 PM - Ewoud Kohl van Wijngaarden
- Has duplicate Bug #25296: Viewing Ansible fact causes errors added

#12 - 04/10/2019 01:44 PM - Ewoud Kohl van Wijngaarden
- Has duplicate Bug #25807: Error viewing external structured puppet fact added

#13 - 05/16/2019 01:44 PM - Marcel Kiihlhorn
- Found in Releases 1.21.2 added

#14 - 08/02/2019 08:32 AM - Marek Hulan
- Related to Feature #26852: Add mountpoint and partition exclude fact patterns added

#15 - 08/02/2019 09:30 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Marek Hulan

- Pull request https://github.com/theforeman/foreman/pull/6950 added

#16 - 08/29/2019 08:10 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/7005 added
#17 - 08/29/2019 10:53 AM - The Foreman Bot
- Fixed in Releases 1.24.0 added

#18 - 08/29/2019 10:54 AM - Tomer Brisker
- Assignee changed from Marek Hulan to Timo Goebel

- Pull request deleted (https://github.com/theforeman/foreman/pull/6950)

#19 - 08/29/2019 11:01 AM - Timo Goebel
- Status changed from Ready For Testing to Closed

Applied in changeset c9648b06e7bcd42e5f291a99613832e21826cac4.
